



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>封装cuda/cudnn写卷积网络前向计算程序</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">封装cuda/cudnn写卷积网络前向计算程序</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 07:29:20 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p>目录</p>
<div>
<ul><li><a href="#基本编译配置" rel="external nofollow noreferrer">基本编译配置</a></li>
<li><a href="#一些常识" rel="external nofollow noreferrer">一些常识</a></li>
<li><a href="#bn层的坑" rel="external nofollow noreferrer">BN层的坑</a></li>
<li><a href="#cuda基础" rel="external nofollow noreferrer">cuda基础</a></li>
<li><a href="#向cuda核函数传入结构体指针" rel="external nofollow noreferrer">向cuda核函数传入结构体指针？</a></li></ul></div>
</div>
<p>参考：<a href="http://galoisplusplus.coding.me/blog/2018/05/22/cudaErrorCudartUnloading/" rel="external nofollow noreferrer">http://galoisplusplus.coding.me/blog/2018/05/22/cudaErrorCudartUnloading/</a></p>
<p>主要是在linux下，使用cuda安装包里的<strong>cuda-memcheck</strong>来检查内存，它是类似于valgrind的存在。</p>
<h2>基本编译配置</h2>
<p>首先添加path：</p>
<pre class="prettyprint linenums"><code>vim ~/.zshrc
export PATH=$PATH:/usr/local/cuda/bin</code></pre>
<p>基于CMake编写C程，cuda相关的内容：</p>
<pre class="prettyprint linenums"><code>option(use_cuda &quot;Use CUDA?&quot; ON)

if (use_cuda)
    #list(APPEND CMAKE_PREFIX_PATH &quot;/usr/local/cuda&quot;)
    if (CMAKE_SYSTEM_NAME MATCHES &quot;Linux&quot;)
        set(CUDA_DIR &quot;/usr/local/cuda&quot;)
        find_package(CUDA REQUIRED)
        include_directories(&quot;${CUDA_DIR}/include&quot;)
        link_directories(&quot;${CUDA_DIR}/lib64&quot;)
    elseif (CMAKE_SYSTEM_NAME MATCHES &quot;Windows&quot;)
        set(CUDA_DIR &quot;$ENV{CUDA_PATH}&quot;)
        find_package(CUDA REQUIRED)
        include_directories(&quot;${CUDA_DIR}/include&quot;)
        link_directories(&quot;${CUDA_DIR}/lib/x64&quot;)
    endif()
endif()

if(use_cuda)
    list(APPEND TESTBED_DEP_LIBS
        cudart
        cudart_static
        cuda
        cublas_device
        cudnn
        cublas
    )
endif()

target_link_libraries(testbed ${TESTBED_DEP_LIBS})</code></pre>
<p>使用：</p>
<pre class="prettyprint linenums"><code>cd ~/work/mycode
mkdir build
cd build
cmake ..
make

cuda-memcheck ./run</code></pre>
<h2>一些常识</h2>
<p>如果cudaMalloc()后忘记cudaFree()，用cuda-memcheck检查不出来这个错误。。据网友说是会自动回收，不知道cuda是否自带了gc功能2333</p>
<h2>BN层的坑</h2>
<p>如果是卷积层，可以直接调用<code>cudnnConvolutionForward()</code>函数，它使用caffe一样的padding方式：它的内部默默的做了对称的padding（pad_left == pad_right），调用起来挺容易的。</p>
<p>倒是BN层卡了好久，主要是官方文档有错误。官方文章这样写的：</p>
<pre class="prettyprint linenums"><code>Note: The input transformation performed by this function is defined as: y := alpha*y + beta *(bnScale * (x-estimatedMean)/sqrt(epsilon + estimatedVariance)+bnBias)

...

alpha, beta
Inputs. Pointers to scaling factors (in host memory) used to blend the layer output value with prior value in the destination tensor as follows: dstValue = alpha[0]*resultValue + beta[0]*priorDstValue.</code></pre>
<p>按照贴出来的文档内容，按它第一行的说法，alpha应该设定为0，beta应该设定为1；按照后面几行的说法，应该是alpha设定为1，beta设定为0。</p>
<ul><li>Caffe：已经很久没有人来修了，它压根没有调用cudnnBatchNormalizationForwardInference()</li>
<li>TensorFlow: 并没有调用。。不信你grep查一下，或者github上网页里在repo中搜索，找不到的。</li>
<li>PyTorch: 还是比较良心，调用了cudnnBatchNormalizationForwardInference( )</li>
<li>mini-caffe: 也是调用了cudnnBatchNormalizationForwardInference( )</li></ul>
<p>主要参考mini-caffe和PyTorch，发现<strong>BN层应该设定alpha为1, beta为0</strong>，这样才能正确算出结果来。看看PyTorch的调用：</p>
<pre class="prettyprint linenums"><code>    AT_CUDNN_CHECK(cudnnBatchNormalizationForwardInference(
      handle, mode, &amp;one, &amp;zero, //这里，alpha是one, beta是zero
      idesc.desc(), input-&gt;data_ptr(),
      idesc.desc(), output-&gt;data_ptr(),
      wdesc.desc(),
      weight-&gt;data_ptr(),
      bias-&gt;data_ptr(),
      running_mean-&gt;data_ptr(),
      running_var-&gt;data_ptr(),
      epsilon));</code></pre>
<p>当然这里还有一个教训：<strong>但凡用CuDNN的xxxDescriptor参数说明的地方，它后面紧接着的几个变量，应该是gpu指针，也就是其值为GPU上的地址，而如果是CPU上的地址就会导致内存错误，比如代码为4或77</strong>。</p>
<p>举例：</p>
<pre class="prettyprint linenums"><code>cudnnStatus = cudnnBatchNormalizationForwardInference(
        layer_base-&gt;handle_cudnn,
        CUDNN_BATCHNORM_PER_ACTIVATION,
        &amp;alpha,
        &amp;beta,
        bnlayer-&gt;bn_layer_input_desc,
        layer_base-&gt;bottom_blobs_ptr[0]-&gt;gpu_data_ptr, //gpu上的
        bnlayer-&gt;bn_layer_output_desc,
        layer_base-&gt;top_blobs_ptr[0]-&gt;gpu_data_ptr, //gpu上的
        bnlayer-&gt;bn_layer_scale_bias_mean_var_desc,
        bnlayer-&gt;scale_dev,  //gpu上的
        bnlayer-&gt;shift_dev,    //gpu上的
        bnlayer-&gt;mean_dev,  //gpu上的
        bnlayer-&gt;variance_dev,//gpu上的
        bnlayer-&gt;eps
);</code></pre>
<h2>cuda基础</h2>
<p>CUDA架构的目的，就是减轻早期GPU计算中存在的限制，这些限制使之前的GPU在通用计算中没有广泛应用。<br />
换言之，CUDA就是为了让NVIDIA GPU用于通用计算的技术。</p>
<p>CUDA编程，使用C/C++即可，它仅仅是增加了个别关键字。不需要使用Shader Language，不需要掌握OpenGL，因此编程门槛降低。</p>
<p>编译器：CUDA C程序需要同时在CPU和N卡上执行计算，分别需要各自的编译器。GPU上的编译器，也就是nvcc了。CPU上的话cl.exe/gcc/clang等。</p>
<p><strong>host和device</strong>: CPU以及main memory，叫做host；GPU上的memory称为device。 内存拷贝的时候，用cudaMemcpy()，要指定内存拷贝的来源和目的地，是host还是device。</p>
<p><strong>kernel</strong>: GPU上执行的函数称为kernel。</p>
<h2>向cuda核函数传入结构体指针？</h2>
<p>C语言传参，本质上是拷贝一份，因此：简单数据类型直接传入即可，反正复制成本低；复杂类型则传入指针，复制成本低。</p>
<p>而如果需要向函数传入多个参数，就希望传入一个结构体或其指针，作为他们的一个封装。</p>
<p>然而，直接向cuda kernel函数传入CPU下的结构体指针是不行的。问题很明显：把host上的指针给device用，寻址会出现问题。</p>
<p>解决思路有三种：</p>
<ol><li>使用host和device的统一寻址</li>
<li>分别创建host和device上的结构体指针，参考https://blog.csdn.net/u013701860/article/details/52605137</li>
<li>向cuda kernel函数传入多个参数</li></ol>
<p>举个栗子：传入结构体的拷贝是OK的(<code>just_demo</code>)，传入host上结构体指针的拷贝，cuda kernel函数会报废的(<code>just_demo2</code>):</p>
<pre class="prettyprint linenums"><code>#include &lt;stdio.h&gt;

#define CHECK_CUDA(call) \
{ \
    const cudaError_t cudaStatus = call; \
    if (cudaStatus != cudaSuccess) { \
        printf(&quot;Error! in file %s, line %d, &quot;, __FILE__, __LINE__); \
        printf(&quot;code: %d, reason: %s\n&quot;, cudaStatus, cudaGetErrorString(cudaStatus)); \
        exit(1); \
    } \
}

typedef struct Pad{
    int left;
    int right;
    int top;
    int bottom;
}Pad;

__global__ void just_demo(Pad pad) {
    printf(&quot;blockIdx: (%d, %d, %d), threadIdx: (%d, %d, %d)&quot;,
            blockIdx.x, blockIdx.y, blockIdx.z,
            threadIdx.x, threadIdx.y, threadIdx.z);
    printf(&quot;pad: left=%d, right=%d, top=%d, bottom=%d\n&quot;,
            pad.left,
            pad.right,
            pad.top,
            pad.bottom);
}

__global__ void just_demo2(Pad* pad) {
    printf(&quot;blockIdx: (%d, %d, %d), threadIdx: (%d, %d, %d)&quot;,
            blockIdx.x, blockIdx.y, blockIdx.z,
            threadIdx.x, threadIdx.y, threadIdx.z);
    printf(&quot;pad: left=%d, right=%d, top=%d, bottom=%d\n&quot;,
            pad-&gt;left,
            pad-&gt;right,
            pad-&gt;top,
            pad-&gt;bottom);
}

int main(void){
    Pad pad;
    pad.left = 1;
    pad.right = 0;
    pad.top = 1;
    pad.bottom = 0;

    size_t buf_size = 3*4*4*sizeof(float);
    float* data_host = (float*)malloc(buf_size);

    float* data_dev;
    CHECK_CUDA(cudaMalloc(&amp;data_dev, buf_size));

    just_demo&lt;&lt;&lt;3, 5&gt;&gt;&gt; (pad);  // this is OK
    //just_demo2&lt;&lt;&lt;3, 5&gt;&gt;&gt; (&amp;pad); // this will cause unspecified launch failure

    CHECK_CUDA(cudaMemcpy(data_host, data_dev, buf_size, cudaMemcpyDeviceToHost));

    return 0;
}</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g8e0y6mq.html">linux 安装 ArcSDE10&period;1</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvzw5o9.html">Maximo 7&period;5 集成方式 去掉主菜单</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8ml15o9.html">1&period;&lbrack;WP Developer体验Andriod开发&rsqb;之Andriod布局 VS WinPhone布局</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy5emg9.html">浏览器缓存相关的Http头介绍&colon;Expires&comma;Cache-Control&comma;Last-Modified&comma;ETag</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8er42jq.html">poj 3321 Apple Trie</a>
		</li>
						<li><a href="https://www.batexi.com/a/390o1ro9.html">ios 7&period;1&period;2 拍照声音</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnwjrz8.html">SDUT 2413&colon;n a&Hat;o7 &excl;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj2n549.html">WPF MultiDataTrigger</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm00609.html">spring集成 log4j &plus; slf4j</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z76o59.html">jQuery三种事件绑定方式&period;bind&lpar;&rpar;&comma;&period;live&lpar;&rpar;&comma;&period;delegate&lpar;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0o3mwq.html">【转】深入理解Java内存模型（二）&mdash;&mdash;重排序</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zxxnj9.html">docpad建站记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjjj5r8.html">hihocoder第41周 骨牌覆盖（矩阵快速幂）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojg7p5q.html">qt中setStyleSheet导致的内存泄漏</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj4nmx9.html">java中的重写与重载</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ozkn18.html">通过该源码修改vim颜色和pudb调试器的代码颜色的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1m7el9.html">Anaconda的下载与安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o15ozxq.html">IDEA加载项目的设置是tomcat</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllk4y1q.html">如何用jQuery获取选中行固定列的数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5kv04q.html">&lbrack;CocoaPods&rsqb;如何使用CocoaPods插件</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9gj4lkl9.html">【运维】Dell R710如何开启VT服务</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2lonoq.html">GeoDesc&colon; Learning Local Descriptors by Integrating Geometry Constraints</a>
			</li>
						<li><a href="https://www.batexi.com/a/90remj39.html">GetCheckProxy</a>
			</li>
						<li><a href="https://www.batexi.com/a/qll5j46q.html">&dollar;Django 站点&colon;样式--文章--分类文章--文章详情--文章评论点赞--文章评论点赞统计&lpar;数据库优化&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7onorx8.html">转载：HBuilder常用快捷键</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wnw0wq.html">下载chrome插件和离线安装CRX文件的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/q250k5wq.html">HTTP协议详解（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwv0lor8.html">CodeVs 3150 &lpar;大数 &plus; 递推）</a>
			</li>
						<li><a href="https://www.batexi.com/a/96053149.html">PHP字符串比较&comma;看起来值完全一样&comma;但是就是不相等的解决方案&lpar;&amp;amp&semi;zwnj&semi;&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qll5o7xq.html">python 安装mysql报错</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
